#----------------------------------------------------------------------------
# array-1d-kopieren.py
#----------------------------------------------------------------------------
# Drei Wege zum Kopieren eines 1-dimensionalen Arrays.
#----------------------------------------------------------------------------

a = [1, 2, 3, 4, 5]
print( 'a: ' + str(a) )

# Variante 1:   -------------------------------------------------------------
# Kopiere Array a in das Array b.
# Dazu wird zuerst Array b mit gleicher Länge wie a erzeugt.
# Anschließend werden alle Einträge von a nach b kopiert.

b = [0] * len(a)          # Erzeuge ein Array der Länge len(a)
                          # und schreibe in jeden Eintrag Wert 0.
for i in range(len(a)):
  b[i] = a[i]

print( 'b: ' + str(b) )

# Variante 2:  --------------------------------------------------------------
# Kopiere Array a in das Array c.
# Erzeuge zuerst ein leeres Array c (Länge 0).
# Gehe durch alle Einträge von a und hänge sie an c an.

c = []            # Erzeuge ein Array der Länge 0.

for i in range(len(a)):
  c += [a[i]]     # hänge Wert a[i] an das Array c an

print( 'c: ' + str(c) )

# Variante 3:  --------------------------------------------------------------
# Kopiere Array a ins Array d.
# Benutze dazu die slice-Funktion von Python.
# a[0:len(a)] ist ein Ausdruck, dessen Wert eine Kopie des Arrays a ist.
# Entsprechend ist a[x:y] ein Ausdruck, dessen Wert ein neues Array
#  [ a[x], a[x+1], ... , a[y-1] ] ist.

d = a[0:len(a)]
print( 'd: ' + str(d) )

# In a[x:y] kann x weggelassen werden wenn x==0, und
# y kann weggelassen werden, wenn y==len(a).
# Damit erhält man noch eine kürzere Schreibweise für a[0:len(a)].

e = a[:]
print( 'e: ' + str(e) )

#----------------------------------------------------------------------------
# python array-1d-kopieren.py 
# a: [1, 2, 3, 4, 5]
# b: [1, 2, 3, 4, 5]
# c: [1, 2, 3, 4, 5]
# d: [1, 2, 3, 4, 5]
# e: [1, 2, 3, 4, 5]


