#---------------------------------------------------------------------------------------------
# doppeltgewuerfelt_v1.py
#---------------------------------------------------------------------------------------------
# Es wird experimentell bestimmt, wie oft man mit einem 6er-Würfel
# würfeln muss, bis man eine Zahl doppelt gewürfelt hat.
# Die Würfe eines Experiments werden in einem Array gewuerfelt mit Indizes 0..6 gespeichert,
# in dem gewuerfelt[i] zu Beginn False ist und auf True gesetzt wird, wenn i gewürfelt wurde.
#---------------------------------------------------------------------------------------------
import random

# Das Experiment wird vorbereitet.
runden = 100000      # die Anzahl der Wiederholungen des Experiments
wurfzaehler = 0      # die Anzahl, wie oft insgesamt gewürfelt wurde

# Das Experiment wird runden mal ausgeführt.
# Es besteht darin, solange zu würfeln, bis eine Zahl zweimal gewürfelt wurde.
for i in range(runden):
  # gewuerfelt[i] ist zu Beginn False und wird auf True gesetzt,
  # wenn i gewürfelt wurde
  gewuerfelt = [False]*7
  # Es wird wiederholt gewürfelt, bis erstmals eine bereits gewürfelte Zahl gewürfelt wird.
  wurf = random.randrange(1,7)
  wurfzaehler += 1
  while not gewuerfelt[wurf]:
     gewuerfelt[wurf] = True           # speichere den Wurf in gewuerfelt
     wurf = random.randrange(1,7)      # würfele nochmal
     wurfzaehler += 1

# Die Experimente werden ausgewertet.
print('Um eine Zahl zweimal zu würfeln, braucht man im Mittel ' 
                             + str(wurfzaehler/runden) + ' Würfe.')
print('Das wurde mit ' + str(runden) + ' Experimenten ermittelt.')

#---------------------------------------------------------------------------------------------
# python3 doppeltgewuerfelt_v1.py 
# Um eine Zahl zweimal zu würfeln, braucht man im Mittel 3.77905 Würfe.
# Das wurde mit 100000 Experimenten ermittelt.
#
# python3 doppeltgewuerfelt_v1.py 
# Um eine Zahl zweimal zu würfeln, braucht man im Mittel 3.77618 Würfe.
# Das wurde mit 100000 Experimenten ermittelt.
# 
# python3 doppeltgewuerfelt_v1.py 
# Um eine Zahl zweimal zu würfeln, braucht man im Mittel 3.77245 Würfe.
# Das wurde mit 100000 Experimenten ermittelt.

