#------------------------------------------------------------------------------------------
# doppeltgewuerfelt_v2.py
#------------------------------------------------------------------------------------------
# Es wird experimentell bestimmt, wie oft man mit einem 6er-Würfel
# würfeln muss, bis man eine Zahl doppelt gewürfelt hat.
# Die Würfe eines Experiments werden im Array gewuerfelt gespeichert,
# das zu Beginn leer ist und an das ein Wurf angehängt wird, wenn er noch nicht vorkommt.
#------------------------------------------------------------------------------------------
import random

# Das Experiment wird vorbereitet.
runden = 100000      # die Anzahl der Wiederholungen des Experiments
wurfzaehler = 0      # die Anzahl, wie oft insgesamt gewürfelt wurde

# Das Experiment wird runden mal ausgeführt.
# Es besteht darin, solange zu würfeln, bis eine Zahl zweimal gewürfelt wurde.
for i in range(runden):
  # gewuerfelt speichert die bereits gewürfelten Zahlen
  gewuerfelt = []
  # Es wird wiederholt gewürfelt, bis erstmals eine bereits gewürfelte Zahl gewürfelt wird.
  wurf = random.randrange(1,7)
  wurfzaehler += 1
  while wurf not in gewuerfelt:
     gewuerfelt += [wurf]           # speichere den Wurf in gewuerfelt
     wurf = random.randrange(1,7)   # würfele nochmal
     wurfzaehler += 1

# Die Experimente werden ausgewertet.
print('Um eine Zahl zweimal zu würfeln, braucht man im Mittel ' 
                             + str(wurfzaehler/runden) + ' Würfe.')
print('Das wurde mit ' + str(runden) + ' Experimenten ermittelt.')

#------------------------------------------------------------------------------------------
# python3 doppeltgewuerfelt_v2.py 
# Um eine Zahl zweimal zu würfeln, braucht man im Mittel 3.77905 Würfe.
# Das wurde mit 100000 Experimenten ermittelt.
#
# python3 doppeltgewuerfelt_v2.py 
# Um eine Zahl zweimal zu würfeln, braucht man im Mittel 3.77618 Würfe.
# Das wurde mit 100000 Experimenten ermittelt.
# 
# python3 doppeltgewuerfelt_v2.py 
# Um eine Zahl zweimal zu würfeln, braucht man im Mittel 3.77245 Würfe.
# Das wurde mit 100000 Experimenten ermittelt.

