#------------------------------------------------------------------------------------------
# geburtstagsparadoxon.py
#------------------------------------------------------------------------------------------
# Es wird experimentell bestimmt, wie viele Personen auf einem Planeten mit einem Jahr aus
# n Tagen man nach ihrem Geburtstag fragen muss, bis man zwei Personen mit dem gleichen
# Geburtstag gefunden hat. 
# Mit "Geburtstag" ist der Tag im Jahr gemeint - das Jahr wird weggelassen.
# Die Zahl n wird von der Kommandozeile eingelesen.
#------------------------------------------------------------------------------------------
import random

# Die Versuchsreihe wird vorbereitet.
n = int( input('Bitte geben Sie die Anzahl der Tage des Jahres ein: ') )
runden = 100000      # die Anzahl der Wiederholungen des Experiments
fragenzaehler = 0    # die Anzahl, wie viele Personen gefragt wurden

# Das Experiment wird runden mal ausgeführt.
# Es besteht darin, solange zu fragen, bis zwei gleiche Geburstage geantwortet wurden.
# Die Geburtstage stammen aus dem Bereich 0...n-1.
for i in range(runden):
  # genannt enthält die bereits genannten Geburtstage
  genannt = []
  # Es wird wiederholt gefragt, bis erstmals eine bereits genannte Zahl auftaucht.
  fragenzaehler += 1
  antwort = random.randrange(n)
  while not antwort in genannt:
     # Speichere, dass die Antwort genannt wurde.
     genannt += [antwort]
     # Frage nach der nächsten Antwort.
     fragenzaehler += 1
     antwort = random.randrange(n)

# Die Versuchsreihe wird ausgewertet.
print('Um auf einem Planeten mit einem ' + str(n) + '-Tage-Jahr zwei Personen mit gleichem')
print('Geburtstag zu finden, braucht man im Mittel ' + str(fragenzaehler/runden) + ' Personen.')
print('Das wurde mit ' + str(runden) + ' Experimenten ermittelt.')

#------------------------------------------------------------------------------------------
# python3 geburtstagsparadoxon.py
# Bitte geben Sie die Anzahl der Tage des Jahres ein: 365
# Um auf einem Planeten mit einem 365-Tage-Jahr zwei Personen mit gleichem
# Geburtstag zu finden, braucht man im Mittel 24.63737 Personen.
# Das wurde mit 100000 Experimenten ermittelt.
#
# python3 geburtstagsparadoxon.py 
# Bitte geben Sie die Anzahl der Tage des Jahres ein: 31
# Um auf einem Planeten mit einem 31-Tage-Jahr zwei Personen mit gleichem
# Geburtstag zu finden, braucht man im Mittel 7.68052 Personen.
# Das wurde mit 100000 Experimenten ermittelt.
#
# python3 geburtstagsparadoxon.py 
# Bitte geben Sie die Anzahl der Tage des Jahres ein: 687
# Um auf einem Planeten mit einem 687-Tage-Jahr zwei Personen mit gleichem
# Geburtstag zu finden, braucht man im Mittel 33.4352 Personen.
# Das wurde mit 100000 Experimenten ermittelt.

