#--------------------------------------------------------------------------------------------------------
# wuerfeln.py
#--------------------------------------------------------------------------------------------------------
# Das Programm bestimmt für alle Zahlen i=2,3,...12, 
# mit welcher Wahrscheinlichkeit sie mit 2 Würfeln gewürfelt werden.
# Beim Aufruf wird von der Kommandozeile der Wert n (int) eingelesen.
# Das Experiment, mit 2 Würfeln zu würfeln, wird n-mal wiederholt.
# Der Ausgang des Experiments ist die gewürfelte Zahl.
# Es wird gezählt, welche Zahl wieoft gewürfelt wurde.
# Am Ende wird die gesuchte Wahrscheinlichkeit für jedes i
# durch den Quotient aus der Anzahl, wieoft i gewürfelt wurde,
# und n abgeschätzt.
#--------------------------------------------------------------------------------------------------------
import random

# Die Experimentreihe wird vorbereitet.
n = int( input('Anzahl der Experimente: ') )   # Die Anzahl der Experimente wird eingelesen.

wuerfe = [0]*13          # wuerfe[i] speichert, wieoft i gewürfelt wurde

# Die Experimentreihe wird durchgeführt.
for e in range(0,n):     # es werden n Experimente durchgeführt
  # Das Experiment: zwei Würfel werden geworfen und ihre Summe wird berechnet.
  wuerfelsumme = random.randrange(1,7) + random.randrange(1,7)
  # Auswertung des Experiments: 
  wuerfe[ wuerfelsumme ] += 1

# Das Ergebnis der Versuchsreihe wird ausgegeben.
for i in range(2,13):
  erfolgsWkeit = wuerfe[i]/n
  print('Die Wahrscheinlichkeit, eine '+str(i)+' zu würfeln, ist ' + str(erfolgsWkeit) + '.' )
  print('  D.h. etwa einer von ' + str(round(1/erfolgsWkeit)) + ' Würfen ist ' +str(i)+'.' )

#--------------------------------------------------------------------------------------------------------
# python3 wuerfeln.py
# Anzahl der Experimente: 1000000
# Die Wahrscheinlichkeit, eine 2 zu würfeln, ist 0.027759.
#   D.h. etwa einer von 36 Würfen ist 2.
# Die Wahrscheinlichkeit, eine 3 zu würfeln, ist 0.055723.
#   D.h. etwa einer von 18 Würfen ist 3.
# Die Wahrscheinlichkeit, eine 4 zu würfeln, ist 0.083432.
#   D.h. etwa einer von 12 Würfen ist 4.
# Die Wahrscheinlichkeit, eine 5 zu würfeln, ist 0.110923.
#   D.h. etwa einer von 9 Würfen ist 5.
# Die Wahrscheinlichkeit, eine 6 zu würfeln, ist 0.138998.
#   D.h. etwa einer von 7 Würfen ist 6.
# Die Wahrscheinlichkeit, eine 7 zu würfeln, ist 0.166332.
#   D.h. etwa einer von 6 Würfen ist 7.
# Die Wahrscheinlichkeit, eine 8 zu würfeln, ist 0.138795.
#   D.h. etwa einer von 7 Würfen ist 8.
# Die Wahrscheinlichkeit, eine 9 zu würfeln, ist 0.111227.
#   D.h. etwa einer von 9 Würfen ist 9.
# Die Wahrscheinlichkeit, eine 10 zu würfeln, ist 0.083128.
#   D.h. etwa einer von 12 Würfen ist 10.
# Die Wahrscheinlichkeit, eine 11 zu würfeln, ist 0.055919.
#   D.h. etwa einer von 18 Würfen ist 11.
# Die Wahrscheinlichkeit, eine 12 zu würfeln, ist 0.027764.
#   D.h. etwa einer von 36 Würfen ist 12.

